import { Def, Defs } from "../types";
/**
 * returns the deepest possible command for the cmdLine string
 * It may be a command with subcommands that it returns
 *
 * @param {Object} arg0 -
 * @param {Object} arg0.cmdLine -
 * @param {Object} arg0.commands - app commands definition
 * @returns {Object} { appCmd, cmdPath, cmdArgs }
 */
declare type Args = {
    cmdLine: string;
    commands: Defs;
};
export declare type CommandMeta = {
    appCmd: Def;
    cmdPath: string[];
    cmdArgs: string;
    cmdArgsList: string[];
};
export declare function findCommand(arg0: Args): Promise<CommandMeta | void>;
export {};
