"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.start = void 0;
var makitso_prompt_1 = require("makitso-prompt");
var debug_1 = require("../debug");
var args_1 = require("./args");
var find_1 = require("./find");
var keypress_autocomplete_1 = require("./keypress-autocomplete");
var keypress_autohelp_1 = require("./keypress-autohelp");
var keypress_command_info_1 = require("./keypress-command-info");
var keypress_validate_1 = require("./keypress-validate");
function runCommandLine(args) {
    return __awaiter(this, void 0, void 0, function () {
        var context, commands, cmdLine, cmd, appCmd, cmdArgs, input;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    context = args.context, commands = args.commands, cmdLine = args.cmdLine;
                    debug_1.debug({ cmdLine: cmdLine });
                    return [4 /*yield*/, find_1.findCommand({ cmdLine: cmdLine, commands: commands })];
                case 1:
                    cmd = _a.sent();
                    if (!cmd) return [3 /*break*/, 3];
                    appCmd = cmd.appCmd, cmdArgs = cmd.cmdArgs;
                    input = args_1.parse({ appCmd: appCmd, cmdArgs: cmdArgs });
                    debug_1.debug({ appCmd: appCmd, cmdArgs: cmdArgs, input: input });
                    if (!appCmd.action) return [3 /*break*/, 3];
                    return [4 /*yield*/, appCmd.action({ commands: commands, context: context, command: appCmd, input: input })];
                case 2:
                    _a.sent();
                    _a.label = 3;
                case 3: return [2 /*return*/];
            }
        });
    });
}
/**
 * Prompt the user for a command and run it
 *
 * @param {Object} args -
 * @param {Object} args.context - An instance of context
 * @param {Object} args.commands - app commands
 * @param {Object} args.options - app options
 * @param {Function|Array} [args.complete=[]] - prompt autocomplete
 * @param {Function} [args.validate] - prompt validation
 * @returns {void}
 */
function promptAndRun(args) {
    return __awaiter(this, void 0, void 0, function () {
        var context, commands, prompt, cmdLine, _a, cmd, appCmd, cmdArgs, input, error_1;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    context = args.context, commands = args.commands, prompt = args.prompt;
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 6, , 7]);
                    _a = "";
                    return [4 /*yield*/, prompt.start()];
                case 2:
                    cmdLine = _a + (_b.sent());
                    debug_1.debug({ cmdLine: cmdLine });
                    return [4 /*yield*/, find_1.findCommand({ cmdLine: cmdLine, commands: commands })];
                case 3:
                    cmd = _b.sent();
                    if (!cmd) return [3 /*break*/, 5];
                    appCmd = cmd.appCmd, cmdArgs = cmd.cmdArgs;
                    input = args_1.parse({ appCmd: appCmd, cmdArgs: cmdArgs });
                    debug_1.debug({ appCmd: appCmd, cmdArgs: cmdArgs, input: input });
                    if (!appCmd.action) return [3 /*break*/, 5];
                    return [4 /*yield*/, appCmd.action({ commands: commands, context: context, command: appCmd, input: input })];
                case 4:
                    _b.sent();
                    _b.label = 5;
                case 5: return [2 /*return*/, promptAndRun(args)];
                case 6:
                    error_1 = _b.sent();
                    if (error_1.message !== "quit") {
                        return [2 /*return*/, Promise.reject(error_1)];
                    }
                    return [3 /*break*/, 7];
                case 7: return [2 /*return*/];
            }
        });
    });
}
function initCommandPrompt(_a) {
    var context = _a.context, commands = _a.commands, prompt = _a.prompt;
    var commandInfo = keypress_command_info_1.keyPressCommandInfo({ context: context, commands: commands });
    var keyPressParser = {
        keyPress: commandInfo,
    };
    var keyPressAutocomplete = {
        keyPress: keypress_autocomplete_1.Autocomplete({ commandInfo: commandInfo }),
    };
    var keyPressAutoHelp = {
        keyPress: keypress_autohelp_1.AutoHelp(),
    };
    var keyPressValidator = {
        keyPress: keypress_validate_1.keyPressValidate(),
    };
    Object.assign(prompt, {
        keyPressers: __spreadArrays([
            {
                keyPress: function (state) {
                    return __awaiter(this, void 0, void 0, function () {
                        return __generator(this, function (_a) {
                            debug_1.debug("keyPresser1", state);
                            return [2 /*return*/, state];
                        });
                    });
                },
            }
        ], prompt.keyPressers, [
            makitso_prompt_1.keyPressHistory,
            keyPressParser,
            keyPressAutocomplete,
            keyPressAutoHelp,
            keyPressValidator,
        ]),
    });
    return prompt;
}
/**
 * Start the console app
 *
 * @param {Object} args -
 * @param {Object} args.context - An instance of context
 * @param {Object} args.commands - app commands
 * @returns {void}
 */
function start(args) {
    return __awaiter(this, void 0, void 0, function () {
        var context, commands, prompt, cmdLine;
        return __generator(this, function (_a) {
            context = args.context, commands = args.commands, prompt = args.prompt, cmdLine = args.cmdLine;
            if (cmdLine) {
                return [2 /*return*/, runCommandLine({ context: context, commands: commands, cmdLine: cmdLine })];
            }
            initCommandPrompt({ context: context, commands: commands, prompt: prompt });
            process.on("SIGINT", function () {
                console.log("Interrupted");
                console.log(prompt.state);
                if (!prompt.state.pojo.returnCommand) {
                    process.exit();
                }
            });
            return [2 /*return*/, promptAndRun({ context: context, commands: commands, prompt: prompt })];
        });
    });
}
exports.start = start;
