"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Autocomplete = void 0;
var every_1 = __importDefault(require("lodash/every"));
var debug_1 = require("../debug");
function allMatch(suggests, match) {
    return every_1.default(suggests, function (choice) { return choice.startsWith(match); });
}
function findCommonPrefix(suggests) {
    var letters = suggests[0].split("");
    debug_1.debug({ suggests: suggests, letters: letters });
    var prefix = letters.shift();
    if (!prefix) {
        return "";
    }
    while (letters.length && allMatch(suggests, prefix)) {
        prefix += letters.shift();
        debug_1.debug({ prefix: prefix });
    }
    return prefix.slice(0, -1);
}
function completedCommandPortion(command) {
    var words = command.split(" ");
    words.pop();
    return words.length ? words.join(" ") + " " : "";
}
function Autocomplete(_a) {
    var commandInfo = _a.commandInfo;
    return function keyPress(state, press) {
        return __awaiter(this, void 0, void 0, function () {
            var commandLine, command, info, text, prefix;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        commandLine = state.commandLine();
                        if (!(state.mode === "command" && commandLine)) return [3 /*break*/, 3];
                        command = commandLine.command;
                        info = state.stash.info;
                        if (!(press.key.name === "tab" && info.suggests && info.suggests.length)) return [3 /*break*/, 2];
                        // set last word of commandline to the prefix common to all suggests
                        command = completedCommandPortion(command);
                        text = void 0;
                        if (info.suggests.length === 1) {
                            text = "" + command + info.suggests[0] + " ";
                        }
                        else {
                            prefix = findCommonPrefix(info.suggests);
                            text = "" + command + prefix;
                        }
                        // debug({ help2: help });
                        state.command = text;
                        return [4 /*yield*/, commandInfo(state)];
                    case 1:
                        _a.sent();
                        _a.label = 2;
                    case 2:
                        (info = state.stash.info);
                        if (info.suggests && info.suggests.length) {
                            state.footer = info.suggests.join(" ");
                        }
                        else {
                            state.footer = "";
                        }
                        _a.label = 3;
                    case 3: return [2 /*return*/, state];
                }
            });
        });
    };
}
exports.Autocomplete = Autocomplete;
