"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.keyPressCommandInfo = void 0;
var filter_1 = __importDefault(require("lodash/filter"));
var args_1 = require("./args");
var find_1 = require("./find");
var debug_1 = require("../debug");
function getSuggests(obj) {
    return filter_1.default(Object.keys(obj), function (choice) { return !choice.startsWith("_"); });
}
function keyPressCommandInfo(_a) {
    var context = _a.context, commands = _a.commands;
    return function keyPress(state) {
        return __awaiter(this, void 0, void 0, function () {
            var cmdLine, cmd, info, appCmd, cmdArgs, _a, _b, filter, matches;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        cmdLine = state.command;
                        return [4 /*yield*/, find_1.findCommand({ cmdLine: cmdLine, commands: commands })];
                    case 1:
                        cmd = _c.sent();
                        info = {};
                        if (!cmd) return [3 /*break*/, 10];
                        appCmd = cmd.appCmd, cmdArgs = cmd.cmdArgs;
                        // info.description = appCmd._description || appCmd.description;
                        info.description = appCmd.description;
                        info.opts = appCmd.opts;
                        info.args = appCmd.args;
                        info.suggests = getSuggests(appCmd.commands || appCmd);
                        info.help = null;
                        if (!!appCmd.commands) return [3 /*break*/, 9];
                        info.input = args_1.parse({ appCmd: appCmd, cmdArgs: cmdArgs, cmdLine: cmdLine });
                        info.hasAction = true;
                        if (!!appCmd.suggest) return [3 /*break*/, 2];
                        info.suggests = [];
                        return [3 /*break*/, 5];
                    case 2:
                        debug_1.debug({ suggestsFn: typeof appCmd.suggest });
                        if (!(typeof appCmd.suggest === "function")) return [3 /*break*/, 4];
                        debug_1.debug(["appCmd.suggest", appCmd.suggest.toString()]);
                        _a = info;
                        return [4 /*yield*/, appCmd.suggest({
                                context: context,
                                command: appCmd,
                                input: info.input,
                            })];
                    case 3:
                        _a.suggests = _c.sent();
                        debug_1.debug(["command.suggests", info.suggests]);
                        return [3 /*break*/, 5];
                    case 4:
                        info.suggests = appCmd.suggest;
                        _c.label = 5;
                    case 5:
                        if (!!appCmd.help) return [3 /*break*/, 6];
                        info.helps = [];
                        return [3 /*break*/, 9];
                    case 6:
                        debug_1.debug({ helpsFn: typeof appCmd.help });
                        if (!(typeof appCmd.help === "function")) return [3 /*break*/, 8];
                        debug_1.debug(["appCmd.help", appCmd.help.toString()]);
                        _b = info;
                        return [4 /*yield*/, appCmd.help({
                                context: context,
                                command: appCmd,
                                input: info.input,
                            })];
                    case 7:
                        _b.help = _c.sent();
                        debug_1.debug(["command.helps", info.help]);
                        return [3 /*break*/, 9];
                    case 8:
                        info.help = appCmd.help;
                        _c.label = 9;
                    case 9: return [3 /*break*/, 11];
                    case 10:
                        info.suggests = getSuggests(commands);
                        _c.label = 11;
                    case 11:
                        debug_1.debug({ cmd: cmd, cmdLine: "\"" + cmdLine + "\"" });
                        filter = "";
                        if (!/\s$/.test(cmdLine)) {
                            filter = (cmd ? cmd.cmdArgsList.pop() : cmdLine) || "";
                        }
                        if (filter) {
                            matches = filter_1.default(info.suggests, function (choice) {
                                return choice.startsWith(filter);
                            });
                            if (matches.length) {
                                info.suggests = matches;
                            }
                        }
                        // state.commandLine({ info });
                        state.stash.info = info;
                        return [2 /*return*/];
                }
            });
        });
    };
}
exports.keyPressCommandInfo = keyPressCommandInfo;
