import { Prompt } from "makitso-prompt";
import { Plugin } from "./types";
/**
 * Start the Makitso app
 *
 * @param {Object} args - args
 * @param {Object} options -
 * @param {String|Prompt} [args.commandPrompt="Makitso>"] - prompt text or makitso-prompt instance
 * @returns {Promise} makitso
 */
declare type MakitsoArgs = {
    plugins: Plugin | Plugin[];
    commandPrompt?: string | Prompt;
    options?: {
        app: {
            description: string;
        };
        prompt: {
            message: string;
        };
    };
    cmdLine?: string;
};
export declare function Makitso(args: MakitsoArgs): Promise<void | Error>;
export {};
