"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.plugin = void 0;
var forEach_1 = __importDefault(require("lodash/forEach"));
var find_1 = require("../command/find");
function write(str) {
    console.log(str);
}
function printCommands(commands, prefix) {
    if (prefix === void 0) { prefix = ""; }
    forEach_1.default(commands, function (command, name) {
        write("" + prefix + name + " - " + (command.description || "No description supplied"));
    });
}
function action(_a) {
    var context = _a.context, input = _a.input;
    return __awaiter(this, void 0, void 0, function () {
        var commands, cmdLine, commandMeta, appCmd;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    commands = context.commands;
                    if (!(input.args.command && input.args.command.length)) return [3 /*break*/, 2];
                    cmdLine = input.args.command.join(" ");
                    return [4 /*yield*/, find_1.findCommand({ cmdLine: cmdLine, commands: commands })];
                case 1:
                    commandMeta = _b.sent();
                    if (commandMeta) {
                        appCmd = commandMeta.appCmd;
                        if (appCmd.commands) {
                            write("\n  " + cmdLine + " sub-commands:\n");
                            printCommands(appCmd.commands, "    ");
                        }
                        else {
                            write("\n  " + cmdLine + " - " + appCmd.description + "\n");
                            if (appCmd.arguments && appCmd.arguments.length) {
                                write("    Arguments:");
                                appCmd.arguments.forEach(function (arg) { return write("      " + arg); });
                            }
                            if (appCmd.options && appCmd.options.length) {
                                write("    Options:");
                                appCmd.options.forEach(function (opt) { return write("      " + opt); });
                            }
                        }
                    }
                    return [3 /*break*/, 3];
                case 2:
                    write("\n  Available commands:\n");
                    printCommands(commands, "    ");
                    _b.label = 3;
                case 3:
                    write("");
                    return [2 /*return*/];
            }
        });
    });
}
function suggest(_a) {
    var context = _a.context, input = _a.input;
    return __awaiter(this, void 0, void 0, function () {
        var commands, cmdLine, command, appCmd;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    commands = context.commands;
                    if (!(input.args.command && input.args.command.length)) return [3 /*break*/, 2];
                    cmdLine = input.args.command.join(" ");
                    return [4 /*yield*/, find_1.findCommand({ cmdLine: cmdLine, commands: commands })];
                case 1:
                    command = _b.sent();
                    if (command) {
                        appCmd = command.appCmd;
                        if (appCmd.commands) {
                            return [2 /*return*/, Object.keys(appCmd.commands)];
                        }
                        return [2 /*return*/, []];
                    }
                    _b.label = 2;
                case 2: return [2 /*return*/, Object.keys(commands).filter(function (comm) { return comm !== "help"; })];
            }
        });
    });
}
var commands = {
    help: {
        description: "Get some help using this tool",
        arguments: ["[command...] - a command to get help with"],
        action: action,
        suggest: suggest,
    },
};
function plugin() {
    return { commands: commands };
}
exports.plugin = plugin;
