import { PluginArgs } from "./stores";
export declare function plugin(args: PluginArgs): Promise<{
    stores: {
        secure: import("./stores/keychain-store").KeychainStore;
        session: import("./stores/memory-store").MemoryStore;
        file?: import("./stores/file-store").FileStore | undefined;
    };
    commands: {
        help: {
            description: string;
            arguments: string[];
            action: ({ context, input }: {
                context: import("..").Context;
                input: import("..").Input;
            }) => Promise<void>;
            suggest: ({ context, input }: {
                context: import("..").Context;
                input: import("..").Input;
            }) => Promise<string[]>;
        };
        quit: {
            description: string;
            action: () => never;
        };
    };
}>;
