import { FileStore, FileStoreArgs } from "./file-store";
import { KeychainStore } from "./keychain-store";
import { MemoryStore, MemoryStoreArgs } from "./memory-store";
export * from "./types";
export declare type PluginArgs = {
    session: MemoryStoreArgs;
    file: FileStoreArgs;
};
declare type Plugin = {
    secure: KeychainStore;
    session: MemoryStore;
    file?: FileStore;
};
export declare function plugin(args: PluginArgs): Promise<Plugin>;
