import * as yargsParseArgs from "yargs-parser";
import { Store, Stores } from "./plugins/stores";
export declare type Stash = {
    info: {};
};
export declare type Argument = {
    name: string;
    description?: string;
    isMulti?: boolean;
    isOptional?: boolean;
    string?: string;
};
export declare type Option = {
    name: string;
    alias: string;
    description: string;
    parseOpt: {
        boolean: boolean;
    };
};
export declare type Plugin = {
    commands?: Commands;
    schema?: ContextSchema;
    stores?: Store[];
};
export declare type PluginSet = {
    commands: Commands;
    schema: ContextSchema;
    stores: Stores;
};
export declare type ContextSchema = {};
export declare type CommandActionInputArgs = {
    [key: string]: string | string[];
};
export declare type CommandActionInput = {
    args: CommandActionInputArgs;
};
export declare type CommandActionArgs = {
    commands: Commands;
    command: Command;
    context: ContextSchema;
    input: CommandActionInput;
};
export declare type CommandSuggestArgs = {
    command: Command;
    context: ContextSchema;
    input: CommandActionInput;
};
export declare type CommandAction = (args: CommandActionArgs) => Promise<void>;
export declare type Command = {
    description?: string;
    action?: CommandAction;
    arguments?: string[];
    options?: string[];
    suggest?: (args: CommandSuggestArgs) => Promise<string[]>;
    help?: (args: {
        context: ContextSchema;
        command: Def;
        input: CommandActionInput;
    }) => string;
    commands?: Commands;
};
export declare type YargsParserOptions = yargsParseArgs.Options;
export declare type YargsParserArguments = yargsParseArgs.Arguments;
export declare type Def = Command & {
    aliasLookup?: {
        [key: string]: string;
    };
    args?: Argument[];
    argsLookup?: {
        [key: string]: number;
    };
    opts?: Option[];
    optsLookup?: {
        [key: string]: boolean;
    };
    argsParserOpts?: yargsParseArgs.Options;
};
export declare type Commands = {
    [key: string]: Command;
};
export declare type Defs = {
    [key: string]: Def;
};
export declare type CommandInfo = {
    description?: string;
    opts?: unknown;
    args?: unknown;
    suggests?: string[];
    help?: unknown;
    hasAction?: boolean;
    helps?: string[];
    input?: CommandActionInput;
};
export declare type CommandInfoArgs = {
    context: ContextSchema;
    commands: Defs;
};
export declare type Context = {
    commands: Defs;
};
export declare type Input = {
    args: {
        command: string[];
    };
};
export declare type ParsedArgs = {
    unknownArgs?: string[];
    unknownOpts?: {
        [key: string]: string[];
    }[];
    args: CommandActionInputArgs;
    missing: Argument[];
    current?: string;
};
